MaterialPackageImpl (Media Authoring with Java API)
Date: 2016-02-05

tv.amwa.maj.model.impl

## Class MaterialPackageImpl

- java.lang.Object
- - tv.amwa.maj.model.impl.InterchangeObjectImpl
  - - tv.amwa.maj.model.impl.PackageImpl
    - - tv.amwa.maj.model.impl.MaterialPackageImpl

- All Implemented Interfaces:
    Serializable, Cloneable, MediaEntity, MetadataObject, WeakReferenceTarget, InterchangeObject, MaterialPackage, Package

      @MediaClass(uuid1=218169601,
                  uuid2=257,
                  uuid3=13824,
                  uuid4={6,14,43,52,2,6,1,1},
                  definedName="MaterialPackage",
                  aliases="MasterMob",
                  description="The MaterialPackage class provides access to the SourcePackages and EssenceData objects.",
                  symbol="MaterialPackage")
      public class MaterialPackageImpl
      extends PackageImpl
      implements MaterialPackage, Serializable, Cloneable

  Implements a material object that provides access to source packages and essence data.

  See Also:
    Serialized Form

- - ### Field Summary

    - ### Fields inherited from class tv.amwa.maj.model.impl.InterchangeObjectImpl

      `ObjectClassPropertyID`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `MaterialPackageImpl()`
    `MaterialPackageImpl(PackageID packageID, String name)` Creates and initializes a material package, which provides access to associated `source package` and `essence data` objects with its unique material identifier and name.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `addMaterialTrack(DataDefinition dataDef, int sourceTrackID, SourcePackage sourcePackage, int masterTrackID, String trackName)` Adds a track to this material package that references the specified track in the specified `source package`.
    `EventTrackImpl` | `appendNewEventTrack(RationalImpl editRate, Segment segment, int trackID, String trackName)`
    `StaticTrackImpl` | `appendNewStaticTrack(Segment segment, int trackID, String trackName)` Creates and returns a new static track with the given property values, as well as appending it to the list of tracks of this package.
    `TimelineTrackImpl` | `appendNewTimelineTrack(Rational editRate, Segment segment, int trackID, String trackName, long origin)` Creates and returns a new timeline track with the given property values, as well as appending it to this package.
    `void` | `appendPhysSourceRef(Rational editrate, int track, DataDefinition essenceKind, SourceReferenceValue ref, long srcRefLength)` Connects this material package with the physical Source package that describes the previous generation of essence, appending it to existing package data.
    `MaterialPackage` | `clone()` Create a cloned copy of this interchange object.
    `short` | `countChannels(int trackID, CriteriaType mediaCrit, DataDefinition mediaKind)` Returns the number of interleaved essence channels of a given type in the essence stream referenced from the given track of this material package.
    `EssenceAccess` | `createEssence(int masterTrackID, DataDefinition mediaKind, AUID codecID, Rational editRate, Rational samplerate, CompressEnable enable, Locator destination, AUID fileFormat)` Creates a single channel stream of essence in the given track of this material package.
    `EssenceAccess` | `createEventEssence(int masterTrackID, DataDefinition mediaKind, AUID codecID, Rational editRate, Rational sampleRate, CompressEnable enable, Locator destination, AUID fileFormat)` Creates and initializes an event track in a track of this material packages that represents a stream of events.
    `EssenceMultiAccess` | `createMultiEssence(AUID codecID, MultiCreateItem[] mediaArray, CompressEnable enable, Locator destination, AUID fileFormat)` Creates a multi-channel interleaved stream of essence for this material package.
    `EssenceAccess` | `createStaticEssence(int masterTrackID, DataDefinition mediaKind, AUID codecID, CompressEnable enable, Locator destination, AUID fileFormat)` Creates and initializes static essence as a referenced track of this material package, returning access to them.
    `EssenceAccess` | `extendEssence(int masterTrackID, DataDefinition mediaKind, AUID codecID, Rational editRate, Rational sampleRate, CompressEnable enable, Locator destintation, AUID fileFormat)` Extends a single stream of essence that was originally created using `createEssence()`.
    `EssenceMultiAccess` | `extendMultiEssence(AUID codecID, MultiCreateItem[] mediaArray, CompressEnable enable, Locator destination, AUID fileFormat)` Extends a multi-channel interleaved stream of essence that was originally created using `createMultiEssence()`.
    `int` | `getAudioRushChannels()`
    `int` | `getAudioRushFrameRateDenominator()`
    `int` | `getAudioRushFrameRateNumerator()`
    `int` | `getAudioRushSampleBits()`
    `SegmentImpl` | `getCriteriaSegment(int trackID, CriteriaType criteria)` Returns the segment on the specified track of this material package that references the source package that best meets the specified criteria.
    `int` | `getNumberOfRepresentations(int trackID)` This function returns the number of media representations available for the specified track of this material package.
    `PackageMarker` | `getPackageMarker()` Returns the package marker for this material package, which specifies an optional sub-section that may be played as an alternative to the full material package.
    `Stream` | `getRemoteRushBlob()`
    `SegmentImpl` | `getRepresentation(int trackID, int index)` This method returns the indexed media representation for this material package, for this given track id and index through the different representations.
    `int` | `getRushFileIsMultipleFrames()`
    `String` | `getRushFilePath()`
    `int` | `getRushIngestTC()`
    `int` | `getRushIngestTCDropframe()`
    `int` | `getRushIngestTCFPS()`
    `int` | `getRushIsFileSequence()`
    `String` | `getTapeName(int masterTrackID)` Finds the tape source package associated with a track of this material package and returns the name of the tape, which is stored in the source package's name property.
    `int` | `getVideoRushBlackLevel()`
    `int` | `getVideoRushChromaRange()`
    `int` | `getVideoRushColourFormat()`
    `int` | `getVideoRushCompression()`
    `int` | `getVideoRushDominance()`
    `int` | `getVideoRushFirstLineIsF2()`
    `int` | `getVideoRushFormatFlags()`
    `int` | `getVideoRushHosepipedRight()`
    `int` | `getVideoRushKeycodeTimeBits()`
    `int` | `getVideoRushKeycodeType()`
    `int` | `getVideoRushKeycodeUserBits()`
    `int` | `getVideoRushPlanes()`
    `int` | `getVideoRushPlaneSize()`
    `int` | `getVideoRushProductionTCTimeBits()`
    `int` | `getVideoRushProductionTCType()`
    `int` | `getVideoRushProductionTCUserBits()`
    `int` | `getVideoRushRenderable()`
    `int` | `getVideoRushScanType()`
    `int` | `getVideoRushVtrTCTimeBits()`
    `int` | `getVideoRushVtrTCType()`
    `int` | `getVideoRushVtrTCUserBits()`
    `int` | `getVideoRushWhiteLevel()`
    `int` | `getVideoRushXAspect()`
    `int` | `getVideoRushXSize()`
    `int` | `getVideoRushYAspect()`
    `int` | `getVideoRushYSize()`
    `void` | `newPhysSourceRef(Rational editrate, int track, DataDefinition essenceKind, SourceReferenceValue ref, long srcRefLength)` Connects this Source package with the physical Source package that describes the previous generation of essence, replacing any existing package data.
    `EssenceAccess` | `openEssence(int trackID, CriteriaType mediaCrit, MediaOpenMode openMode, CompressEnable compEnable)` Opens a single channel of a file source package referenced from a track of this material package.
    `EssenceMultiAccess` | `openMultiEssence(int trackID, CriteriaType mediaCrit, MediaOpenMode openMode, CompressEnable compEnable)` Opens all channels associated with a file source package referenced from this material package.
    `void` | `setAudioRushChannels(Integer audioRushChannels)`
    `void` | `setAudioRushFrameRateDenominator(Integer audioRushFrameRateDenominator)`
    `void` | `setAudioRushFrameRateNumerator(Integer audioRushFrameRateNumerator)`
    `void` | `setAudioRushSampleBits(Integer audioRushSampleBits)`
    `void` | `setPackageMarker(PackageMarker packageMarker)` Sets the package marker for this material package, which specifies an optional sub-section that may be played as an alternative to the full material package.
    `void` | `setRemoteRushBlob(Stream remoteRushBlob)`
    `void` | `setRushFileIsMultipleFrames(Integer rushFileIsMultipleFrames)`
    `void` | `setRushFilePath(String rushFilePath)`
    `void` | `setRushIngestTC(Integer audioRushFrameRateDenominator)`
    `void` | `setRushIngestTCDropFrame(Integer rushIngestTCDropframe)`
    `void` | `setRushIngestTCFPS(Integer rushIngestTCFPS)`
    `void` | `setRushIsFileSequence(int rushIsFileSequence)`
    `void` | `setVideoRushBlackLevel(Integer videoRushBlackLevel)`
    `void` | `setVideoRushChromaRange(Integer videoRushChromaRange)`
    `void` | `setVideoRushColourFormat(Integer videoRushColourFormat)`
    `void` | `setVideoRushCompression(Integer videoRushCompression)`
    `void` | `setVideoRushDominance(Integer videoRushDominance)`
    `void` | `setVideoRushFirstLineIsF2(Integer videoRushFirstLineIsF2)`
    `void` | `setVideoRushFormatFlags(Integer videoRushFormatFlags)`
    `void` | `setVideoRushHosepipedRight(Integer videoRushHosepipedRight)`
    `void` | `setVideoRushKeycodeTimeBits(Integer videoRushKeycodeTimeBits)`
    `void` | `setVideoRushKeycodeType(Integer videoRushKeycodeType)`
    `void` | `setVideoRushKeycodeUserBits(Integer videoRushKeycodeUserBits)`
    `void` | `setVideoRushPlanes(Integer videoRushPlanes)`
    `void` | `setVideoRushPlaneSize(Integer videoRushPlaneSize)`
    `void` | `setVideoRushProductionTCTimeBits(Integer videoRushProductionTCTimeBits)`
    `void` | `setVideoRushProductionTCType(Integer videoRushProductionTCType)`
    `void` | `setVideoRushProductionTCUserBits(Integer videoRushProductionTCUserBits)`
    `void` | `setVideoRushRenderable(Integer videoRushRenderable)`
    `void` | `setVideoRushScanType(Integer videoRushScanType)`
    `void` | `setVideoRushVtrTCTimeBits(Integer videoRushVtrTCTimeBits)`
    `void` | `setVideoRushVtrTCType(Integer videoRushVtrTCType)`
    `void` | `setVideoRushVtrTCUserBits(Integer videoRushVtrTCUserBits)`
    `void` | `setVideoRushWhiteLevel(Integer videoRushWhiteLevel)`
    `void` | `setVideoRushXAspect(Integer videoRushXAspect)`
    `void` | `setVideoRushXSize(Integer videoRushXSize)`
    `void` | `setVideoRushYAspect(Integer videoRushYAspect)`
    `void` | `setVideoRushYSize(Integer videoRushYSize)`

    - ### Methods inherited from class tv.amwa.maj.model.impl.PackageImpl

      `appendMobAttributeItem, appendNewEventTrack, appendPackageAttribute, appendPackageAttribute, appendPackageKLVData, appendPackageTrack, appendPackageUserComment, appendPackageUserComment, changeReference, clearMobAttributeList, clearPackageAttributes, clearPackageKLVData, clearPackageTracks, clearPackageUserComments, cloneExternal, copy, countMobAttributeList, countPackageAttributes, countPackageKLVData, countPackageTracks, countPackageUserComments, getAUID, getConvertFrameRate, getCreationTime, getCreationTimeString, getMobAttributeItemAt, getMobAttributeList, getPackageAttributes, getPackageID, getPackageIDString, getPackageKLVData, getPackageLastModified, getPackageLastModifiedString, getPackageName, getPackageTrackAt, getPackageTracks, getPackageUsage, getPackageUsageString, getPackageUserComments, getSubclipBegin, getSubclipFullLength, getWeakTargetReference, initializeCreationTime, initializePackageID, initializePackageLastModified, initializePackageTracks, insertMobAttributeItem, insertPackageTrackAt, lookupPackageTrack, offsetToPackageTimecode, prependMobAttributeItem, prependPackageAttribute, prependPackageKLVData, prependPackageTrack, prependPackageUserComment, removeMobAttributeItemAt, removePackageAttribute, removePackageKLVData, removePackageTrackAt, removePackageUserComment, setConvertFrameRate, setCreationTime, setCreationTimeString, setPackageID, setPackageIDString, setPackageLastModified, setPackageLastModifiedString, setPackageName, setPackageUsage, setPackageUsageString, setSubclipBegin, setSubclipFullLength`

    - ### Methods inherited from class tv.amwa.maj.model.impl.InterchangeObjectImpl

      `addApplicationPlugin, appendXMLChildren, clearApplicationPlugins, containsApplicationPlugin, containsApplicationPlugin, countApplicationPlugins, deepEquals, disableGenerationTracking, enableGenerationTracking, equals, getApplicationPlugins, getComment, getGeneration, getLinkedGenerationID, getLinkedGenerationIDString, getObjectClass, getPersistentID, getPersistentIndex, hashCode, isGenerationTracked, removeApplicationPlugin, removeApplicationPlugin, setLinkedGenerationID, setLinkedGenerationIDString, setObjectClass, setPersistentID, setPersistentIndex, toString`

    - ### Methods inherited from class java.lang.Object

      `getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface tv.amwa.maj.model.Package

      `appendNewEventTrack, appendPackageAttribute, appendPackageAttribute, appendPackageKLVData, appendPackageTrack, appendPackageUserComment, appendPackageUserComment, changeReference, clearPackageAttributes, clearPackageKLVData, clearPackageTracks, clearPackageUserComments, cloneExternal, copy, countPackageAttributes, countPackageKLVData, countPackageTracks, countPackageUserComments, getCreationTime, getPackageAttributes, getPackageID, getPackageKLVData, getPackageLastModified, getPackageName, getPackageTrackAt, getPackageTracks, getPackageUsage, getPackageUserComments, insertPackageTrackAt, lookupPackageTrack, offsetToPackageTimecode, prependPackageTrack, removePackageAttribute, removePackageKLVData, removePackageTrackAt, removePackageUserComment, setCreationTime, setPackageID, setPackageLastModified, setPackageName, setPackageUsage`

    - ### Methods inherited from interface tv.amwa.maj.model.InterchangeObject

      `addApplicationPlugin, clearApplicationPlugins, containsApplicationPlugin, containsApplicationPlugin, countApplicationPlugins, deepEquals, disableGenerationTracking, enableGenerationTracking, equals, getApplicationPlugins, getGeneration, getLinkedGenerationID, getObjectClass, isGenerationTracked, removeApplicationPlugin, removeApplicationPlugin, setLinkedGenerationID, setObjectClass, toString`

    - ### Methods inherited from interface tv.amwa.maj.industry.MediaEntity

      `getPersistentID, setPersistentIndex`

    - ### Methods inherited from interface tv.amwa.maj.industry.WeakReferenceTarget

      `getAUID, getWeakTargetReference`

- - ### Constructor Detail

    - #### MaterialPackageImpl

          public MaterialPackageImpl()

    - #### MaterialPackageImpl

          public MaterialPackageImpl(PackageID packageID,
                                     @AAFString
                                     String name)
                              throws NullPointerException

      Creates and initializes a material package, which provides access to associated `source package` and `essence data` objects with its unique material identifier and name. The required properties of creation time and last modified time will be set automatically to the time of calling this method. These timestamp values can be set manually by calling `setCreateTime()` and and `setModTime()`.

      Parameters:
        `packageID` - Unique material identifier for the package.
        `name` - Name of the material package.
      Throws:
        `NullPointerException` - Unique material identifier is `null`.

  - ### Method Detail

    - #### getPackageMarker

          @MediaProperty(uuid1=100729092,
                         uuid2=20,
                         uuid3=0,
                         uuid4={6,14,43,52,1,1,1,12},
                         definedName="PackageMarker",
                         aliases="PackageMarkerObject",
                         typeName="PackageMarkerStrongReference",
                         optional=true,
                         uniqueIdentifier=false,
                         symbol="PackageMarker",
                         pid=0,
                         description="Package marker for this material package, which specifies an optional sub-section that may be played as an alternative to the full material package.")
          public PackageMarker getPackageMarker()
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                             throws PropertyNotPresentException

      Description copied from interface: `MaterialPackage`

      Returns the package marker for this material package, which specifies an optional sub-section that may be played as an alternative to the full material package. This is an optional property.

      Specified by:
        `getPackageMarker` in interface `MaterialPackage`
      Returns:
        Package marker for this material package.
      Throws:
        `PropertyNotPresentException` - The optional package marker property is not present for this material package.

    - #### setPackageMarker

          @MediaPropertySetter(value="PackageMarker")
          public void setPackageMarker(PackageMarker packageMarker)

      Description copied from interface: `MaterialPackage`

      Sets the package marker for this material package, which specifies an optional sub-section that may be played as an alternative to the full material package. Set this optional property to `null` to omit it.

      Specified by:
        `setPackageMarker` in interface `MaterialPackage`
      Parameters:
        `packageMarker` - Package marker for this material package.

    - #### addMaterialTrack

          public void addMaterialTrack(DataDefinition dataDef,
                                       int sourceTrackID,
                                       SourcePackage sourcePackage,
                                       int masterTrackID,
                                       String trackName)
                                throws NullPointerException,
                                       InvalidDataDefinitionException,
                                       TrackNotFoundException,
                                       TrackExistsException

      Description copied from interface: `MaterialPackage`

      Adds a track to this material package that references the specified track in the specified `source package`. The new track in the material package contains a `source clip` that specifies the `source package` in its source reference properties.

      Specified by:
        `addMaterialTrack` in interface `MaterialPackage`
      Parameters:
        `dataDef` - Essence kind of the new track. Requires an essence kind valid for time-varying essence, such as: "Picture", "Sound".
        `sourceTrackID` - Track id of the source track to be referenced from this material package.
        `sourcePackage` - Source package containing the track to be referenced from this material package.
        `masterTrackID` - Track id to be assigned to the new material track.
        `trackName` - Name to assign to new track in the material package. Set this property to `null` to omit the optional track name.
      Throws:
        `NullPointerException` - One or both of the data definition and/or source package parameters is/are `null`.
        `InvalidDataDefinitionException` - The data kind of the source track to be added to the material package does not match what is specified in `dataDefinition`.
        `TrackNotFoundException` - The given source track was not found.
        `TrackExistsException` - The given material track id already identifies a track in this material package.
      See Also:
        `SourceClip`, `TimelineTrack`, `Package.getPackageTracks()`

    - #### appendPhysSourceRef

          public void appendPhysSourceRef(Rational editrate,
                                          int track,
                                          DataDefinition essenceKind,
                                          SourceReferenceValue ref,
                                          long srcRefLength)
                                   throws NullPointerException

      Description copied from interface: `MaterialPackage`

      Connects this material package with the physical Source package that describes the previous generation of essence, appending it to existing package data. If a physical Source package, such as a File Source package or tape Source package, references another physical Source package as its ancestor, with no pulldown, then this function makes the connection between the two.

      Functionally, this is a helper method to create a track with an `SourceClip` referencing a particular piece of media. This method takes many parameters because the components of an `SourceReferenceValue` have been broken out as separate parameters.

      The ancestor of a `SourcePackage` with an `AAFFileDescriptor` is often a `TapeDescriptor` or `null`.

      Specified by:
        `appendPhysSourceRef` in interface `MaterialPackage`
      Parameters:
        `editrate` - Edit rate of track to contain reference.
        `track` - Track id of track to contain reference.
        `essenceKind` - Data kind of track to contain reference. Requires a data kind valid for a essence stream. Valid data kinds are: "`Picture`", "`Sound`"
        `ref` - Reference to a Physical Source package.
        `srcRefLength` - Length of the Source Clip.
      Throws:
        `NullPointerException` - One or more of the arguments is null.

    - #### countChannels

          public short countChannels(int trackID,
                                     CriteriaType mediaCrit,
                                     DataDefinition mediaKind)
                              throws NullPointerException,
                                     TrackNotFoundException

      Description copied from interface: `MaterialPackage`

      Returns the number of interleaved essence channels of a given type in the essence stream referenced from the given track of this material package. This method is structured so that it can be called before essence is opened.

      If the data format is not interleaved, then the answer will always be zero or one. This function correctly returns zero for essence types not handled by a given codec, and handles codecs which work with multiple essence types.

      Specified by:
        `countChannels` in interface `MaterialPackage`
      Parameters:
        `trackID` - Count channels on this track of this material package.
        `mediaCrit` - Filter channels using this media criteria.
        `mediaKind` - Count channels of this kind of essence.
      Returns:
        Number of channels in the given track, matching the given media criteria and essence kind.
      Throws:
        `NullPointerException` - One or both of the media criteria and/or media kind arguments is/are `null`.
        `TrackNotFoundException` - The specified track does not exist in this material package.

    - #### createEssence

          public EssenceAccess createEssence(int masterTrackID,
                                             DataDefinition mediaKind,
                                             AUID codecID,
                                             Rational editRate,
                                             Rational samplerate,
                                             CompressEnable enable,
                                             Locator destination,
                                             AUID fileFormat)
                                      throws NullPointerException

      Description copied from interface: `MaterialPackage`

      Creates a single channel stream of essence in the given track of this material package. Convenience functions exist to create audio or video essence, and a separate call (`MaterialPackage.createMultiEssence(AUID, MultiCreateItem[], CompressEnable, Locator, AUID)`) exists to create interleaved audio and video data.

      The essence handle from this call can be used with `EssenceAccess.writeSamples(int, byte[])`, but not with `EssenceMultiAccess.writeMultiSamples(MultiXferItem[])`.

      For video, the sample rate should be the edit rate of the file source package. For audio, the sample rate should be the actual number of samples per second.

      Specified by:
        `createEssence` in interface `MaterialPackage`
      Parameters:
        `masterTrackID` - Material track id for the new essence.
        `mediaKind` - Create essence of this type.
        `codecID` - Create essence according to this codec.
        `editRate` - Create essence with this edit rate.
        `samplerate` - Create essence with this sample rate.
        `enable` - Is compression enabled?
        `destination` - Create the essence at this location, or `null` for the default location.
        `fileFormat` - Create essence to this file format.
      Returns:
        Access to the created essence.
      Throws:
        `NullPointerException` - One or more of the required arguments is `null`.

    - #### createEventEssence

          public EssenceAccess createEventEssence(int masterTrackID,
                                                  DataDefinition mediaKind,
                                                  AUID codecID,
                                                  Rational editRate,
                                                  Rational sampleRate,
                                                  CompressEnable enable,
                                                  Locator destination,
                                                  AUID fileFormat)
                                           throws NullPointerException

      Description copied from interface: `MaterialPackage`

      Creates and initializes an event track in a track of this material packages that represents a stream of events.

      This method is broadly similar to `createEssence()` except that the essence is created in a `event track` in this material package.

      The essence handle from this call can be used with `EssenceAccess.writeSamples(int, byte[])` but not with `EssenceMultiAccess.writeMultiSamples(MultiXferItem[])`.

      Specified by:
        `createEventEssence` in interface `MaterialPackage`
      Parameters:
        `masterTrackID` - Track of this material package in which to create the event essence.
        `mediaKind` - Create essence of this type.
        `codecID` - Create essence with this codec.
        `editRate` - Create essence with this edit rate.
        `sampleRate` - Create essence with this sample rate.
        `enable` - Compress the created essence?
        `destination` - Optionally create a the essence file at this location.
        `fileFormat` - If the file is created, use this file format, as specified by the identifier of a container definition.
      Returns:
        Access to the newly created essence.
      Throws:
        `NullPointerException` - One or more of the required arguments is/are `null`.
      See Also:
        `ContainerConstant`, `CodecConstant`

    - #### createMultiEssence

          public EssenceMultiAccess createMultiEssence(AUID codecID,
                                                       MultiCreateItem[] mediaArray,
                                                       CompressEnable enable,
                                                       Locator destination,
                                                       AUID fileFormat)
                                                throws NullPointerException

      Description copied from interface: `MaterialPackage`

      Creates a multi-channel interleaved stream of essence for this material package. The essence handle from this call can be used with `EssenceAccess.writeSamples(int, byte[])` or `EssenceMultiAccess.writeMultiSamples(MultiXferItem[])`.

      Specified by:
        `createMultiEssence` in interface `MaterialPackage`
      Parameters:
        `codecID` - Create multi-essence using this codec.
        `mediaArray` - Create multi-essence using this array of definitions.
        `enable` - Is multi-essence compressed?
        `destination` - Create the interleaved essence file at this location, or `null` for default location.
        `fileFormat` - If a file is created, use this file format as specified by the identifier of a container definition.
      Returns:
        Access to the created multi-essence.
      Throws:
        `NullPointerException` - One or more of the required arguments is `null`.

    - #### createStaticEssence

          public EssenceAccess createStaticEssence(int masterTrackID,
                                                   DataDefinition mediaKind,
                                                   AUID codecID,
                                                   CompressEnable enable,
                                                   Locator destination,
                                                   AUID fileFormat)
                                            throws NullPointerException

      Description copied from interface: `MaterialPackage`

      Creates and initializes static essence as a referenced track of this material package, returning access to them.

      This method is broadly similar to `createEssence()` except that the essence is created in a `static track` in this material package.

      The essence handle from this call can be used with `EssenceAccess.writeSamples(int, byte[])` but not with `EssenceMultiAccess.writeMultiSamples(MultiXferItem[])`.

      Specified by:
        `createStaticEssence` in interface `MaterialPackage`
      Parameters:
        `masterTrackID` - Track of this material package in which to create static essence.
        `mediaKind` - Create essence of this type.
        `codecID` - Create essence using this codec.
        `enable` - Compress the created essence?
        `destination` - Optionally create the essence file at this location.
        `fileFormat` - If the file is created, use this file format, as specified by a `container definition`.
      Returns:
        Access to the newly created essence.
      Throws:
        `NullPointerException` - One or more of the required arguments is/are `null`.
      See Also:
        `ContainerConstant`

    - #### extendEssence

          public EssenceAccess extendEssence(int masterTrackID,
                                             DataDefinition mediaKind,
                                             AUID codecID,
                                             Rational editRate,
                                             Rational sampleRate,
                                             CompressEnable enable,
                                             Locator destintation,
                                             AUID fileFormat)
                                      throws NullPointerException

      Description copied from interface: `MaterialPackage`

      Extends a single stream of essence that was originally created using `createEssence()`. Extended essence is represented by a sequence of source clips. The first call to this method will cause the timeline track's source clip object to be replaced by a sequence. The initial source clip becomes the first component of the new sequence.

      Specified by:
        `extendEssence` in interface `MaterialPackage`
      Parameters:
        `masterTrackID` - Track id of the essence to be extended on this material package.
        `mediaKind` - Create the extended essence with this type.
        `codecID` - Create the extended essence with this codec.
        `editRate` - Create the extended essence with this edit rate.
        `sampleRate` - Create the extended essence with this sample rage.
        `enable` - Should the extended essence by compressed?
        `destintation` - Optionally create a file of extended essence at this location.
        `fileFormat` - If a file is created, use this file format, as specified by a the identifier of a container definition.
      Returns:
        Essence access to the newly extended essence.
      Throws:
        `NullPointerException` - One of more of the required arguments is/are `null`.

    - #### extendMultiEssence

          public EssenceMultiAccess extendMultiEssence(AUID codecID,
                                                       MultiCreateItem[] mediaArray,
                                                       CompressEnable enable,
                                                       Locator destination,
                                                       AUID fileFormat)
                                                throws NullPointerException

      Description copied from interface: `MaterialPackage`

      Extends a multi-channel interleaved stream of essence that was originally created using `createMultiEssence()`. Extended essence is represented by a sequence of source clips. The first call to this method will cause the timeline track's source clip to be replaced by a sequence. The initial source clip becomes the first component of the new sequence.

      Specified by:
        `extendMultiEssence` in interface `MaterialPackage`
      Parameters:
        `codecID` - Extend the multi-channel essence using this codec.
        `mediaArray` - Use these media definitions to extend the essence.
        `enable` - Should the extension be done with compression enabled?
        `destination` - Optionally create a file at this location.
        `fileFormat` - If the file is created, use this format, as specified by the identifier of a container definition.
      Returns:
        Essence access to the extended essence.
      Throws:
        `NullPointerException` - One or more of the required arguments is/are `null`.
      See Also:
        `MultiCreateItem`, `ContainerConstant`

    - #### getCriteriaSegment

          public SegmentImpl getCriteriaSegment(int trackID,
                                                CriteriaType criteria)
                                         throws TrackNotFoundException,
                                                NullPointerException

      Description copied from interface: `MaterialPackage`

      Returns the segment on the specified track of this material package that references the source package that best meets the specified criteria. This function will return a result whether multiple media representations exist or not, as one representation not matching a criteria is considered better than no representation for any given media criteria.

      Specified by:
        `getCriteriaSegment` in interface `MaterialPackage`
      Parameters:
        `trackID` - Track id of a track of this material package to return a representation for.
        `criteria` - Criteria for selecting one of the segments.
      Returns:
        Matching segment.
      Throws:
        `TrackNotFoundException` - The material track specified by track id was not found.
        `NullPointerException` - One or both of the track id and/or criteria is/are `null`.

    - #### getNumberOfRepresentations

          public int getNumberOfRepresentations(int trackID)
                                         throws TrackNotFoundException

      Description copied from interface: `MaterialPackage`

      This function returns the number of media representations available for the specified track of this material package. Each different representation will have a media criteria that can be used to select it. Use `MaterialPackage.getCriteriaSegment(int, CriteriaType)` to handle multiple representations.

      Specified by:
        `getNumberOfRepresentations` in interface `MaterialPackage`
      Parameters:
        `trackID` - Track id the count of the number of representations are required for.
      Returns:
        Number of different media type representations in the track.
      Throws:
        `TrackNotFoundException` - The material track specified by track is was not found for this material package.

    - #### getRepresentation

          public SegmentImpl getRepresentation(int trackID,
                                               int index)
                                        throws TrackNotFoundException,
                                               IndexOutOfBoundsException

      Description copied from interface: `MaterialPackage`

      This method returns the indexed media representation for this material package, for this given track id and index through the different representations. This call is designed to work with `MaterialPackage.getNumberOfRepresentations(int)` so that the user can iterate through all of the choices. This method uses an integer index, not an iterator. The method takes an index between 0 and one less than the number of representations, and returns the source package at that representation index.

      Specified by:
        `getRepresentation` in interface `MaterialPackage`
      Parameters:
        `trackID` - Track id of this material package to find a representation for.
        `index` - Index of media representation in the given track.
      Returns:
        Matching source clip.
      Throws:
        `TrackNotFoundException` - The material track specified by track id was not found in this material package.
        `IndexOutOfBoundsException` - No media representation is available at the specified index.
      See Also:
        `CriteriaType`

    - #### getTapeName

          public String getTapeName(int masterTrackID)
                             throws TrackNotFoundException,
                                    NotTapePackageException

      Description copied from interface: `MaterialPackage`

      Finds the tape source package associated with a track of this material package and returns the name of the tape, which is stored in the source package's name property. If the property name has not yet been set, a zero-length string will be returned.

      A tape source package is a source package described by a tape descriptor.

      Specified by:
        `getTapeName` in interface `MaterialPackage`
      Parameters:
        `masterTrackID` - Track id of this material track to use to find the tape name.
      Returns:
        Tape name of the tape source package in the given track.
      Throws:
        `TrackNotFoundException` - The specified material track was not found.
        `NotTapePackageException` - The specified material track does not contain a tape package.
      See Also:
        `TapeDescriptor`, `SourcePackage.getEssenceDescriptor()`

    - #### newPhysSourceRef

          public void newPhysSourceRef(Rational editrate,
                                       int track,
                                       DataDefinition essenceKind,
                                       SourceReferenceValue ref,
                                       long srcRefLength)
                                throws NullPointerException

      Description copied from interface: `MaterialPackage`

      Connects this Source package with the physical Source package that describes the previous generation of essence, replacing any existing package data. If a physical Source package, such as a File Source package or tape Source package, references another physical Source package as its ancestor, with no pulldown, then this function makes the connection between the two.

      Functionally, this is a helper method to create a track with a `SourceClip` referencing a particular piece of media. This function takes many parameters because the components of a `SourceReferenceValue` have been broken out as separate parameters.

      The ancestor of an source package with an `AAFFileDescriptor` is often an `TapeDescriptor` or `null`.

      Specified by:
        `newPhysSourceRef` in interface `MaterialPackage`
      Throws:
        `NullPointerException`

    - #### openEssence

          public EssenceAccess openEssence(int trackID,
                                           CriteriaType mediaCrit,
                                           MediaOpenMode openMode,
                                           CompressEnable compEnable)
                                    throws NullPointerException,
                                           TrackNotFoundException

      Description copied from interface: `MaterialPackage`

      Opens a single channel of a file source package referenced from a track of this material package. If the essence is interleaved, then it will be de-interleaved when samples are read. This routine follows the locator of the source package's essence descriptor.

      The essence handle from this call can be used with `EssenceAccess.readSamples(int)`, but NOT with `EssenceMultiAccess.readMultiSamples(MultiXferItem[])`.

      Specified by:
        `openEssence` in interface `MaterialPackage`
      Parameters:
        `trackID` - Open essence on this track.
        `mediaCrit` - Select essence using this criteria.
        `openMode` - Open essence with this mode, either read only or append.
        `compEnable` - Should the essence be decompressed?
      Returns:
        Access to the essence.
      Throws:
        `NullPointerException` - One or more of the arguments was null.
        `TrackNotFoundException` - The specified track does not exist in the material package.

    - #### openMultiEssence

          public EssenceMultiAccess openMultiEssence(int trackID,
                                                     CriteriaType mediaCrit,
                                                     MediaOpenMode openMode,
                                                     CompressEnable compEnable)
                                              throws NullPointerException,
                                                     TrackNotFoundException

      Description copied from interface: `MaterialPackage`

      Opens all channels associated with a file source package referenced from this material package. This routine follows the locator of the essence descriptor of the source package.

      The essence handle from this call can be used with `EssenceMultiAccess.writeMultiSamples(MultiXferItem[])` but not with `EssenceAccess.writeSamples(int, byte[])`.

      Specified by:
        `openMultiEssence` in interface `MaterialPackage`
      Parameters:
        `trackID` - Track id of this material package referencing the essence to open.
        `mediaCrit` - Select a kind of representation of the content in the track using this criteria.
        `openMode` - Open mode for essence access, either `MediaOpenMode.ReadOnly` or `MediaOpenMode.Append`.
        `compEnable` - Should the essence be decompressed?
      Returns:
        Access to the multi-channel essence.
      Throws:
        `NullPointerException` - One or more of the media criteria, open mode or compress enable arguments is/are `null`.
        `TrackNotFoundException` - The given track does not exist in this material package.

    - #### appendNewEventTrack

          public EventTrackImpl appendNewEventTrack(RationalImpl editRate,
                                                    Segment segment,
                                                    int trackID,
                                                    String trackName)
                                             throws NullPointerException

      Throws:
        `NullPointerException`

    - #### appendNewStaticTrack

          public StaticTrackImpl appendNewStaticTrack(Segment segment,
                                                      int trackID,
                                                      String trackName)
                                               throws NullPointerException

      Description copied from interface: `Package`

      Creates and returns a new static track with the given property values, as well as appending it to the list of tracks of this package.

      Specified by:
        `appendNewStaticTrack` in interface `Package`
      Overrides:
        `appendNewStaticTrack` in class `PackageImpl`
      Parameters:
        `segment` - Segment to use to create a new static track.
        `trackID` - Track id to assign to the new static track.
        `trackName` - Name for the new static track, or `null` to omit this optional property.
      Returns:
        Newly created static track, which is also appended to the list of tracks of this package.
      Throws:
        `NullPointerException` - The given segment is `null`.
      See Also:
        `Package.appendPackageTrack(Track)`

    - #### appendNewTimelineTrack

          public TimelineTrackImpl appendNewTimelineTrack(Rational editRate,
                                                          Segment segment,
                                                          int trackID,
                                                          String trackName,
                                                          long origin)
                                                   throws NullPointerException

      Description copied from interface: `Package`

      Creates and returns a new timeline track with the given property values, as well as appending it to this package.

      Specified by:
        `appendNewTimelineTrack` in interface `Package`
      Overrides:
        `appendNewTimelineTrack` in class `PackageImpl`
      Parameters:
        `editRate` - Units of time for the new timeline track.
        `segment` - Value for the new timeline track.
        `trackID` - Integer to be used to refer to the track.
        `trackName` - Name of the new timeline track, or `null` to omit this optional property.
        `origin` - Specifies the offset used to resolve source clip references to source material in the new timeline track, measured in according to the edit rate of the new track. A positive value means that the first sample of the essence is earlier than the zero position. A negative value of origin means that the zero position is earlier than the first sample of the essence.
      Returns:
        The newly created timeline tracl, which is also appended to the list of tracks of this package.
      Throws:
        `NullPointerException` - One or more of the arguments is `null`.

    - #### getRushIngestTCDropframe

          @MediaProperty(uuid1=1174937349,
                         uuid2=-7790,
                         uuid3=19002,
                         uuid4={-118,-70,-98,7,109,-126,8,24},
                         definedName="Rush ingest tc dropframe",
                         symbol="Rush_ingest_tc_dropframe",
                         aliases="Rush_ingest_tc_dropframe",
                         typeName="Int32",
                         optional=true,
                         uniqueIdentifier=false,
                         pid=0,
                         prefix="q",
                         namespace="http://www.quantel.com/genQ/extensions")
           @Int32
          public int getRushIngestTCDropframe()

    - #### setRushIngestTCDropFrame

          @MediaPropertySetter(value="Rush ingest tc dropframe")
          public void setRushIngestTCDropFrame(@Int32
                                                                                                      Integer rushIngestTCDropframe)

    - #### getVideoRushFirstLineIsF2

          @MediaProperty(uuid1=-1910562809,
                         uuid2=-31644,
                         uuid3=19302,
                         uuid4={-124,35,85,78,63,-30,111,-87},
                         definedName="Video rush firstLineIsF2",
                         symbol="Video_rush_firstLineIsF2",
                         aliases="Video_rush_firstLineIsF2",
                         typeName="Int32",
                         optional=true,
                         uniqueIdentifier=false,
                         pid=0,
                         prefix="q",
                         namespace="http://www.quantel.com/genQ/extensions")
           @Int32
          public int getVideoRushFirstLineIsF2()

    - #### setVideoRushFirstLineIsF2

          @MediaPropertySetter(value="Video rush firstLineIsF2")
          public void setVideoRushFirstLineIsF2(@Int32
                                                                                                       Integer videoRushFirstLineIsF2)

    - #### getVideoRushChromaRange

          @MediaProperty(uuid1=-2104095479,
                         uuid2=31489,
                         uuid3=17884,
                         uuid4={-74,-24,-90,-10,83,-114,114,-23},
                         definedName="Video rush chroma range",
                         symbol="Video_rush_chroma_range",
                         aliases="Video_rush_chroma_range",
                         typeName="UInt32",
                         optional=true,
                         uniqueIdentifier=false,
                         pid=0,
                         prefix="q",
                         namespace="http://www.quantel.com/genQ/extensions")
           @UInt32
          public int getVideoRushChromaRange()

    - #### setVideoRushChromaRange

          @MediaPropertySetter(value="Video rush chroma range")
          public void setVideoRushChromaRange(@UInt32
                                                                                                    Integer videoRushChromaRange)

    - #### getVideoRushProductionTCUserBits

          @MediaProperty(uuid1=-1726238960,
                         uuid2=24987,
                         uuid3=17302,
                         uuid4={-77,-101,-27,50,19,-55,-34,65},
                         definedName="Video rush production tc user bits",
                         symbol="Video_rush_production_tc_user_bits",
                         aliases="Video_rush_production_tc_user_bits",
                         typeName="UInt32",
                         optional=true,
                         uniqueIdentifier=false,
                         pid=0,
                         prefix="q",
                         namespace="http://www.quantel.com/genQ/extensions")
           @UInt32
          public int getVideoRushProductionTCUserBits()

    - #### setVideoRushProductionTCUserBits

          @MediaPropertySetter(value="Video rush production tc user bits")
          public void setVideoRushProductionTCUserBits(@UInt32
                                                                                                                        Integer videoRushProductionTCUserBits)

    - #### getAudioRushChannels

          @MediaProperty(uuid1=590602260,
                         uuid2=23326,
                         uuid3=18176,
                         uuid4={-103,105,-7,76,21,-16,33,-103},
                         definedName="Audio rush channels",
                         symbol="Audio_rush_channels",
                         aliases="Audio_rush_channels",
                         typeName="UInt32",
                         optional=true,
                         uniqueIdentifier=false,
                         pid=0,
                         prefix="q",
                         namespace="http://www.quantel.com/genQ/extensions")
           @UInt32
          public int getAudioRushChannels()

    - #### setAudioRushChannels

          @MediaPropertySetter(value="Audio rush channels")
          public void setAudioRushChannels(@UInt32
                                                                                             Integer audioRushChannels)

    - #### getVideoRushProductionTCType

          @MediaProperty(uuid1=-1084162274,
                         uuid2=-7852,
                         uuid3=17685,
                         uuid4={-126,54,-42,84,13,25,125,38},
                         definedName="Video rush production tc type",
                         symbol="Video_rush_production_tc_type",
                         aliases="Video_rush_production_tc_type",
                         typeName="UInt32",
                         optional=true,
                         uniqueIdentifier=false,
                         pid=0,
                         prefix="q",
                         namespace="http://www.quantel.com/genQ/extensions")
           @UInt32
          public int getVideoRushProductionTCType()

    - #### setVideoRushProductionTCType

          @MediaPropertySetter(value="Video rush production tc type")
          public void setVideoRushProductionTCType(@UInt32
                                                                                                               Integer videoRushProductionTCType)

    - #### getVideoRushKeycodeUserBits

          @MediaProperty(uuid1=-299868385,
                         uuid2=-13143,
                         uuid3=18127,
                         uuid4={-91,-101,90,80,-101,-121,-35,47},
                         definedName="Video rush keycode user bits",
                         symbol="Video_rush_keycode_user_bits",
                         aliases="Video_rush_keycode_user_bits",
                         typeName="UInt32",
                         optional=true,
                         uniqueIdentifier=false,
                         pid=0,
                         prefix="q",
                         namespace="http://www.quantel.com/genQ/extensions")
           @UInt32
          public int getVideoRushKeycodeUserBits()

    - #### setVideoRushKeycodeUserBits

          @MediaPropertySetter(value="Video rush keycode user bits")
          public void setVideoRushKeycodeUserBits(@UInt32
                                                                                                             Integer videoRushKeycodeUserBits)

    - #### getVideoRushYAspect

          @MediaProperty(uuid1=-86459866,
                         uuid2=8605,
                         uuid3=18625,
                         uuid4={-101,-64,-104,73,62,-49,38,-68},
                         definedName="Video rush y aspect",
                         symbol="Video_rush_y_aspect",
                         aliases="Video_rush_y_aspect",
                         typeName="UInt32",
                         optional=true,
                         uniqueIdentifier=false,
                         pid=0,
                         prefix="q",
                         namespace="http://www.quantel.com/genQ/extensions")
           @UInt32
          public int getVideoRushYAspect()

    - #### setVideoRushYAspect

          @MediaPropertySetter(value="Video rush y aspect")
          public void setVideoRushYAspect(@UInt32
                                                                                            Integer videoRushYAspect)

    - #### getVideoRushProductionTCTimeBits

          @MediaProperty(uuid1=749820715,
                         uuid2=118,
                         uuid3=19260,
                         uuid4={-124,-53,68,49,-94,-42,-30,-12},
                         definedName="Video rush production tc time bits",
                         symbol="Video_rush_production_tc_time_bits",
                         aliases="Video_rush_production_tc_time_bits",
                         typeName="UInt32",
                         optional=true,
                         uniqueIdentifier=false,
                         pid=0,
                         prefix="q",
                         namespace="http://www.quantel.com/genQ/extensions")
           @UInt32
          public int getVideoRushProductionTCTimeBits()

    - #### setVideoRushProductionTCTimeBits

          @MediaPropertySetter(value="Video rush production tc time bits")
          public void setVideoRushProductionTCTimeBits(@UInt32
                                                                                                                        Integer videoRushProductionTCTimeBits)

    - #### getVideoRushDominance

          @MediaProperty(uuid1=1888974382,
                         uuid2=-1198,
                         uuid3=18348,
                         uuid4={-123,-58,-95,125,-123,23,-6,-115},
                         definedName="Video rush dominance",
                         symbol="Video_rush_dominance",
                         aliases="Video_rush_dominance",
                         typeName="Int32",
                         optional=true,
                         uniqueIdentifier=false,
                         pid=0,
                         prefix="q",
                         namespace="http://www.quantel.com/genQ/extensions")
           @Int32
          public int getVideoRushDominance()

    - #### setVideoRushDominance

          @MediaPropertySetter(value="Video rush dominance")
          public void setVideoRushDominance(@Int32
                                                                                               Integer videoRushDominance)

    - #### getVideoRushBlackLevel

          @MediaProperty(uuid1=710504258,
                         uuid2=-28004,
                         uuid3=17318,
                         uuid4={-67,74,38,101,-85,32,77,44},
                         definedName="Video rush black level",
                         symbol="Video_rush_black_level",
                         aliases="Video_rush_black_level",
                         typeName="UInt32",
                         optional=true,
                         uniqueIdentifier=false,
                         pid=0,
                         prefix="q",
                         namespace="http://www.quantel.com/genQ/extensions")
           @UInt32
          public int getVideoRushBlackLevel()

    - #### setVideoRushBlackLevel

          @MediaPropertySetter(value="Video rush black level")
          public void setVideoRushBlackLevel(@UInt32
                                                                                                  Integer videoRushBlackLevel)

    - #### getAudioRushSampleBits

          @MediaProperty(uuid1=2122700635,
                         uuid2=-706,
                         uuid3=16563,
                         uuid4={-89,126,-40,-32,-32,23,12,-95},
                         definedName="Audio rush sample bits",
                         symbol="Audio_rush_sample_bits",
                         aliases="Audio_rush_sample_bits",
                         typeName="UInt32",
                         optional=true,
                         uniqueIdentifier=false,
                         pid=0,
                         prefix="q",
                         namespace="http://www.quantel.com/genQ/extensions")
           @UInt32
          public int getAudioRushSampleBits()

    - #### setAudioRushSampleBits

          @MediaPropertySetter(value="Audio rush sample bits")
          public void setAudioRushSampleBits(@UInt32
                                                                                                  Integer audioRushSampleBits)

    - #### getRushIngestTCFPS

          @MediaProperty(uuid1=-1958778259,
                         uuid2=-8076,
                         uuid3=16837,
                         uuid4={-80,64,-126,-31,-52,43,-80,49},
                         definedName="Rush ingest tc fps",
                         symbol="Rush_ingest_tc_fps",
                         aliases="Rush_ingest_tc_fps",
                         typeName="Int32",
                         optional=true,
                         uniqueIdentifier=false,
                         pid=0,
                         prefix="q",
                         namespace="http://www.quantel.com/genQ/extensions")
           @Int32
          public int getRushIngestTCFPS()

    - #### setRushIngestTCFPS

          @MediaPropertySetter(value="Rush ingest tc fps")
          public void setRushIngestTCFPS(@Int32
                                                                                          Integer rushIngestTCFPS)

    - #### getVideoRushPlaneSize

          @MediaProperty(uuid1=-791586959,
                         uuid2=-18338,
                         uuid3=20240,
                         uuid4={-91,-65,-52,-49,-56,-98,14,-58},
                         definedName="Video rush plane size",
                         symbol="Video_rush_plane_size",
                         aliases="Video_rush_plane_size",
                         typeName="UInt32",
                         optional=true,
                         uniqueIdentifier=false,
                         pid=0,
                         prefix="q",
                         namespace="http://www.quantel.com/genQ/extensions")
           @UInt32
          public int getVideoRushPlaneSize()

    - #### setVideoRushPlaneSize

          @MediaPropertySetter(value="Video rush plane size")
          public void setVideoRushPlaneSize(@UInt32
                                                                                                Integer videoRushPlaneSize)

    - #### getVideoRushVtrTCType

          @MediaProperty(uuid1=-224349321,
                         uuid2=29275,
                         uuid3=20315,
                         uuid4={-116,-4,-43,-34,-28,-37,-9,-119},
                         definedName="Video rush vtr tc type",
                         symbol="Video_rush_vtr_tc_type",
                         aliases="Video_rush_vtr_tc_type",
                         typeName="UInt32",
                         optional=true,
                         uniqueIdentifier=false,
                         pid=0,
                         prefix="q",
                         namespace="http://www.quantel.com/genQ/extensions")
           @UInt32
          public int getVideoRushVtrTCType()

    - #### setVideoRushVtrTCType

          @MediaPropertySetter(value="Video rush vtr tc type")
          public void setVideoRushVtrTCType(@UInt32
                                                                                                 Integer videoRushVtrTCType)

    - #### getAudioRushFrameRateNumerator

          @MediaProperty(uuid1=-931689604,
                         uuid2=16347,
                         uuid3=19200,
                         uuid4={-72,127,-47,-20,-88,-17,-87,-37},
                         definedName="Audio rush frame rate numerator",
                         symbol="Audio_rush_frame_rate_numerator",
                         aliases="Audio_rush_frame_rate_numerator",
                         typeName="Int32",
                         optional=true,
                         uniqueIdentifier=false,
                         pid=0,
                         prefix="q",
                         namespace="http://www.quantel.com/genQ/extensions")
           @Int32
          public int getAudioRushFrameRateNumerator()

    - #### setAudioRushFrameRateNumerator

          @MediaPropertySetter(value="Audio rush frame rate numerator")
          public void setAudioRushFrameRateNumerator(@Int32
                                                                                                                   Integer audioRushFrameRateNumerator)

    - #### getRushFilePath

          @MediaProperty(uuid1=-1796324992,
                         uuid2=-31960,
                         uuid3=18685,
                         uuid4={-105,-68,-107,-30,-68,-77,12,-72},
                         definedName="Rush file path",
                         symbol="Rush_file_path",
                         aliases="Rush_file_path",
                         typeName="UTF16String",
                         optional=true,
                         uniqueIdentifier=false,
                         pid=0,
                         prefix="q",
                         namespace="http://www.quantel.com/genQ/extensions")
          public String getRushFilePath()

    - #### setRushFilePath

          @MediaPropertySetter(value="Rush file path")
          public void setRushFilePath(String rushFilePath)

    - #### getRushIsFileSequence

          @MediaProperty(uuid1=2038626688,
                         uuid2=3325,
                         uuid3=18965,
                         uuid4={-99,8,10,49,30,-75,-109,13},
                         definedName="Rush is file sequence",
                         symbol="Rush_is_file_sequence",
                         aliases="Rush_is_file_sequence",
                         typeName="Int32",
                         optional=true,
                         uniqueIdentifier=false,
                         pid=0,
                         prefix="q",
                         namespace="http://www.quantel.com/genQ/extensions")
           @Int32
          public int getRushIsFileSequence()

    - #### setRushIsFileSequence

          @MediaPropertySetter(value="Rush is file sequence")
          public void setRushIsFileSequence(@Int32
                                                                                                int rushIsFileSequence)

    - #### getVideoRushRenderable

          @MediaProperty(uuid1=-1964649838,
                         uuid2=-31126,
                         uuid3=17898,
                         uuid4={-121,-17,-17,7,-83,41,84,43},
                         definedName="Video rush renderable",
                         symbol="Video_rush_renderable",
                         aliases="Video_rush_renderable",
                         typeName="UInt32",
                         optional=true,
                         uniqueIdentifier=false,
                         pid=0,
                         prefix="q",
                         namespace="http://www.quantel.com/genQ/extensions")
           @UInt32
          public int getVideoRushRenderable()

    - #### setVideoRushRenderable

          @MediaPropertySetter(value="Video rush renderable")
          public void setVideoRushRenderable(@UInt32
                                                                                                 Integer videoRushRenderable)

    - #### getVideoRushHosepipedRight

          @MediaProperty(uuid1=1519537820,
                         uuid2=-6371,
                         uuid3=17516,
                         uuid4={-128,-125,-2,113,18,-120,-79,109},
                         definedName="Video rush hosepiped right",
                         symbol="Video_rush_hosepiped_right",
                         aliases="Video_rush_hosepiped_right",
                         typeName="UInt32",
                         optional=true,
                         uniqueIdentifier=false,
                         pid=0,
                         prefix="q",
                         namespace="http://www.quantel.com/genQ/extensions")
           @UInt32
          public int getVideoRushHosepipedRight()

    - #### setVideoRushHosepipedRight

          @MediaPropertySetter(value="Video rush hosepiped right")
          public void setVideoRushHosepipedRight(@UInt32
                                                                                                          Integer videoRushHosepipedRight)

    - #### getVideoRushCompression

          @MediaProperty(uuid1=-517472096,
                         uuid2=-29723,
                         uuid3=16652,
                         uuid4={-116,-23,-73,-2,64,-106,50,-12},
                         definedName="Video rush compression",
                         symbol="Video_rush_compression",
                         aliases="Video_rush_compression",
                         typeName="UInt32",
                         optional=true,
                         uniqueIdentifier=false,
                         pid=0,
                         prefix="q",
                         namespace="http://www.quantel.com/genQ/extensions")
           @UInt32
          public int getVideoRushCompression()

    - #### setVideoRushCompression

          @MediaPropertySetter(value="Video rush compression")
          public void setVideoRushCompression(@UInt32
                                                                                                   Integer videoRushCompression)

    - #### getRemoteRushBlob

          @MediaProperty(uuid1=2038895781,
                         uuid2=31054,
                         uuid3=17239,
                         uuid4={-68,-2,73,24,37,-7,-55,-11},
                         definedName="Remote rush blob",
                         symbol="Remote_rush_blob",
                         aliases="Remote_rush_blob",
                         typeName="Stream",
                         optional=true,
                         uniqueIdentifier=false,
                         pid=0,
                         prefix="q",
                         namespace="http://www.quantel.com/genQ/extensions")
          public Stream getRemoteRushBlob()

    - #### setRemoteRushBlob

          @MediaPropertySetter(value="Remote rush blob")
          public void setRemoteRushBlob(Stream remoteRushBlob)

    - #### getVideoRushXSize

          @MediaProperty(uuid1=-944117841,
                         uuid2=13533,
                         uuid3=18354,
                         uuid4={-123,52,46,12,14,-29,-19,92},
                         definedName="Video rush x size",
                         symbol="Video_rush_x_size",
                         aliases="Video_rush_x_size",
                         typeName="UInt32",
                         optional=true,
                         uniqueIdentifier=false,
                         pid=0,
                         prefix="q",
                         namespace="http://www.quantel.com/genQ/extensions")
           @UInt32
          public int getVideoRushXSize()

    - #### setVideoRushXSize

          @MediaPropertySetter(value="Video rush x size")
          public void setVideoRushXSize(@UInt32
                                                                                        Integer videoRushXSize)

    - #### getVideoRushVtrTCTimeBits

          @MediaProperty(uuid1=-1272648017,
                         uuid2=28805,
                         uuid3=19539,
                         uuid4={-71,106,-94,-47,-128,48,49,-98},
                         definedName="Video rush vtr tc time bits",
                         symbol="Video_rush_vtr_tc_time_bits",
                         aliases="Video_rush_vtr_tc_time_bits",
                         typeName="UInt32",
                         optional=true,
                         uniqueIdentifier=false,
                         pid=0,
                         prefix="q",
                         namespace="http://www.quantel.com/genQ/extensions")
           @UInt32
          public int getVideoRushVtrTCTimeBits()

    - #### setVideoRushVtrTCTimeBits

          @MediaPropertySetter(value="Video rush vtr tc time bits")
          public void setVideoRushVtrTCTimeBits(@UInt32
                                                                                                          Integer videoRushVtrTCTimeBits)

    - #### getVideoRushYSize

          @MediaProperty(uuid1=1693708463,
                         uuid2=23485,
                         uuid3=18876,
                         uuid4={-77,-74,71,95,-30,-83,116,-107},
                         definedName="Video rush y size",
                         symbol="Video_rush_y_size",
                         aliases="Video_rush_y_size",
                         typeName="UInt32",
                         optional=true,
                         uniqueIdentifier=false,
                         pid=0,
                         prefix="q",
                         namespace="http://www.quantel.com/genQ/extensions")
           @UInt32
          public int getVideoRushYSize()

    - #### setVideoRushYSize

          @MediaPropertySetter(value="Video rush y size")
          public void setVideoRushYSize(@UInt32
                                                                                        Integer videoRushYSize)

    - #### getVideoRushColourFormat

          @MediaProperty(uuid1=-1603343949,
                         uuid2=-17864,
                         uuid3=17111,
                         uuid4={-99,-74,-98,106,-53,-33,-12,4},
                         definedName="Video rush colour format",
                         symbol="Video_rush_colour_format",
                         aliases="Video_rush_colour_format",
                         typeName="UInt32",
                         optional=true,
                         uniqueIdentifier=false,
                         pid=0,
                         prefix="q",
                         namespace="http://www.quantel.com/genQ/extensions")
           @UInt32
          public int getVideoRushColourFormat()

    - #### setVideoRushColourFormat

          @MediaPropertySetter(value="Video rush colour format")
          public void setVideoRushColourFormat(@UInt32
                                                                                                      Integer videoRushColourFormat)

    - #### getVideoRushKeycodeTimeBits

          @MediaProperty(uuid1=-198415947,
                         uuid2=-14801,
                         uuid3=18721,
                         uuid4={-79,-39,37,99,25,-102,112,6},
                         definedName="Video rush keycode time bits",
                         symbol="Video_rush_keycode_time_bits",
                         aliases="Video_rush_keycode_time_bits",
                         typeName="UInt32",
                         optional=true,
                         uniqueIdentifier=false,
                         pid=0,
                         prefix="q",
                         namespace="http://www.quantel.com/genQ/extensions")
           @UInt32
          public int getVideoRushKeycodeTimeBits()

    - #### setVideoRushKeycodeTimeBits

          @MediaPropertySetter(value="Video rush keycode time bits")
          public void setVideoRushKeycodeTimeBits(@UInt32
                                                                                                             Integer videoRushKeycodeTimeBits)

    - #### getVideoRushVtrTCUserBits

          @MediaProperty(uuid1=576000694,
                         uuid2=-31252,
                         uuid3=18280,
                         uuid4={-65,-40,-123,-124,58,124,-54,65},
                         definedName="Video rush vtr tc user bits",
                         symbol="Video_rush_vtr_tc_user_bits",
                         aliases="Video_rush_vtr_tc_user_bits",
                         typeName="UInt32",
                         optional=true,
                         uniqueIdentifier=false,
                         pid=0,
                         prefix="q",
                         namespace="http://www.quantel.com/genQ/extensions")
           @UInt32
          public int getVideoRushVtrTCUserBits()

    - #### setVideoRushVtrTCUserBits

          @MediaPropertySetter(value="Video rush vtr tc user bits")
          public void setVideoRushVtrTCUserBits(@UInt32
                                                                                                          Integer videoRushVtrTCUserBits)

    - #### getVideoRushFormatFlags

          @MediaProperty(uuid1=1052410556,
                         uuid2=-5754,
                         uuid3=17142,
                         uuid4={-87,-15,-110,61,-81,-68,-44,-97},
                         definedName="Video rush format flags",
                         symbol="Video_rush_format_flags",
                         aliases="Video_rush_format_flags",
                         typeName="UInt32",
                         optional=true,
                         uniqueIdentifier=false,
                         pid=0,
                         prefix="q",
                         namespace="http://www.quantel.com/genQ/extensions")
           @UInt32
          public int getVideoRushFormatFlags()

    - #### setVideoRushFormatFlags

          @MediaPropertySetter(value="Video rush format flags")
          public void setVideoRushFormatFlags(@UInt32
                                                                                                    Integer videoRushFormatFlags)

    - #### getVideoRushScanType

          @MediaProperty(uuid1=-872833603,
                         uuid2=-10276,
                         uuid3=19622,
                         uuid4={-77,-43,111,76,-80,-91,-72,2},
                         definedName="Video rush scan type",
                         symbol="Video_rush_scan_type",
                         aliases="Video_rush_scan_type",
                         typeName="Int32",
                         optional=true,
                         uniqueIdentifier=false,
                         pid=0,
                         prefix="q",
                         namespace="http://www.quantel.com/genQ/extensions")
           @Int32
          public int getVideoRushScanType()

    - #### setVideoRushScanType

          @MediaPropertySetter(value="Video rush scan type")
          public void setVideoRushScanType(@Int32
                                                                                              Integer videoRushScanType)

    - #### getRushFileIsMultipleFrames

          @MediaProperty(uuid1=-872863030,
                         uuid2=-31494,
                         uuid3=19393,
                         uuid4={-108,-58,41,48,75,9,-91,-67},
                         definedName="Rush file is multiple frames",
                         symbol="Rush_file_is_multiple_frames",
                         aliases="Rush_file_is_multiple_frames",
                         typeName="Int32",
                         optional=true,
                         uniqueIdentifier=false,
                         pid=0,
                         prefix="q",
                         namespace="http://www.quantel.com/genQ/extensions")
           @Int32
          public int getRushFileIsMultipleFrames()

    - #### setRushFileIsMultipleFrames

          @MediaPropertySetter(value="Rush file is multiple frames")
          public void setRushFileIsMultipleFrames(@Int32
                                                                                                             Integer rushFileIsMultipleFrames)

    - #### getAudioRushFrameRateDenominator

          @MediaProperty(uuid1=-1276414770,
                         uuid2=-11810,
                         uuid3=16659,
                         uuid4={-123,-39,-3,25,-35,108,106,59},
                         definedName="Audio rush frame rate denominator",
                         symbol="Audio_rush_frame_rate_denominator",
                         aliases="Audio_rush_frame_rate_denominator",
                         typeName="Int32",
                         optional=true,
                         uniqueIdentifier=false,
                         pid=0,
                         prefix="q",
                         namespace="http://www.quantel.com/genQ/extensions")
           @Int32
          public int getAudioRushFrameRateDenominator()

    - #### setAudioRushFrameRateDenominator

          @MediaPropertySetter(value="Audio rush frame rate denominator")
          public void setAudioRushFrameRateDenominator(@Int32
                                                                                                                       Integer audioRushFrameRateDenominator)

    - #### getVideoRushPlanes

          @MediaProperty(uuid1=1297176784,
                         uuid2=-6409,
                         uuid3=18800,
                         uuid4={-68,65,103,125,-58,21,3,-105},
                         definedName="Video rush planes",
                         symbol="Video_rush_planes",
                         aliases="Video_rush_planes",
                         typeName="UInt32",
                         optional=true,
                         uniqueIdentifier=false,
                         pid=0,
                         prefix="q",
                         namespace="http://www.quantel.com/genQ/extensions")
           @UInt32
          public int getVideoRushPlanes()

    - #### setVideoRushPlanes

          @MediaPropertySetter(value="Video rush planes")
          public void setVideoRushPlanes(@UInt32
                                                                                         Integer videoRushPlanes)

    - #### getRushIngestTC

          @MediaProperty(uuid1=-1332866092,
                         uuid2=-18311,
                         uuid3=19795,
                         uuid4={-115,-37,52,-67,118,77,-46,-76},
                         definedName="Rush ingest tc",
                         symbol="Rush_ingest_tc",
                         aliases="Rush_ingest_tc",
                         typeName="Int32",
                         optional=true,
                         uniqueIdentifier=false,
                         pid=0,
                         prefix="q",
                         namespace="http://www.quantel.com/genQ/extensions")
           @Int32
          public int getRushIngestTC()

    - #### setRushIngestTC

          @MediaPropertySetter(value="Rush ingest tc")
          public void setRushIngestTC(@Int32
                                                                                   Integer audioRushFrameRateDenominator)

    - #### getVideoRushWhiteLevel

          @MediaProperty(uuid1=245453030,
                         uuid2=17635,
                         uuid3=19781,
                         uuid4={-107,77,-66,-92,-45,120,107,-104},
                         definedName="Video rush white level",
                         symbol="Video_rush_white_level",
                         aliases="Video_rush_white_level",
                         typeName="UInt32",
                         optional=true,
                         uniqueIdentifier=false,
                         pid=0,
                         prefix="q",
                         namespace="http://www.quantel.com/genQ/extensions")
           @UInt32
          public int getVideoRushWhiteLevel()

    - #### setVideoRushWhiteLevel

          @MediaPropertySetter(value="Video rush white level")
          public void setVideoRushWhiteLevel(@UInt32
                                                                                                  Integer videoRushWhiteLevel)

    - #### getVideoRushKeycodeType

          @MediaProperty(uuid1=150195953,
                         uuid2=24490,
                         uuid3=17813,
                         uuid4={-108,92,-12,-79,38,102,-28,102},
                         definedName="Video rush keycode type",
                         symbol="Video_rush_keycode_type",
                         aliases="Video_rush_keycode_type",
                         typeName="UInt32",
                         optional=true,
                         uniqueIdentifier=false,
                         pid=0,
                         prefix="q",
                         namespace="http://www.quantel.com/genQ/extensions")
           @UInt32
          public int getVideoRushKeycodeType()

    - #### setVideoRushKeycodeType

          @MediaPropertySetter(value="Video rush keycode type")
          public void setVideoRushKeycodeType(@UInt32
                                                                                                    Integer videoRushKeycodeType)

    - #### getVideoRushXAspect

          @MediaProperty(uuid1=-820107276,
                         uuid2=-22055,
                         uuid3=18769,
                         uuid4={-85,46,-89,50,-126,21,-19,96},
                         definedName="Video rush x aspect",
                         symbol="Video_rush_x_aspect",
                         aliases="Video_rush_x_aspect",
                         typeName="UInt32",
                         optional=true,
                         uniqueIdentifier=false,
                         pid=0,
                         prefix="q",
                         namespace="http://www.quantel.com/genQ/extensions")
           @UInt32
          public int getVideoRushXAspect()

    - #### setVideoRushXAspect

          @MediaPropertySetter(value="Video rush x aspect")
          public void setVideoRushXAspect(@UInt32
                                                                                            Integer videoRushXAspect)

    - #### clone

          public MaterialPackage clone()

      Description copied from interface: `InterchangeObject`

      Create a cloned copy of this interchange object.

      Specified by:
        `clone` in interface `MediaEntity`
      Specified by:
        `clone` in interface `InterchangeObject`
      Specified by:
        `clone` in interface `MaterialPackage`
      Specified by:
        `clone` in interface `Package`
      Overrides:
        `clone` in class `PackageImpl`
      Returns:
        Cloned copy of this interchange object.

(c)2007-2016 Richard Cartwright, all rights reserved. Licensed under Apache 2 license and subject to the AMWA IPR policy.